//Сальдовая ведомость по жэку

include("Objects/DpJRegistrator.js");

var jID = getPar("HOCPAYREG");	//журнал реестрации (по умолч. KU)
var tblOut = getTmpTableName();	//таблица с результатами
var tblSku = "RAS_SKU";			//таблица счетов за коммунальные услуги
var tblReg = null;				//таблица журнала регистрации
var label  = "VEDKU";			//метка для печати
var streetID;					//id улицы
var houseID;					//id дома
var lot;						//участок
var gek;						//ЖЭК
var platCod;
var rdat1;						//нач. дата расчета
var rdat2;						//кон. дата расчета

function listLoad()
{
	//this.xmlGridFile = "r_vedku.xml";
	this.printLabel = label;
	this.accDel = null;  	
}

function listDpGrid()
{
	grid.setXMLFile("r_vedku.xml");
	//grid.getColumn("FHOT").setCaption(UR("10й поверх|10й этаж"));
	//grid.getColumn("FGAS").setCaption(UR("Комора|Кладовка"));
	//grid.getColumn("FOTHER").setCaption(UR("Теплове навантаження"));
	grid.build();
}

function listTitle()
{
	var sCapt = ru("Сальдовая ведомость", "Сальдова відомість");
	
	var dat1 = list.objAsk.idat1;
	var dat2 = list.objAsk.idat2;
	var oStreet = list.objAsk.istreet;
	var oHouse = list.objAsk.ihouse;
	
	if(dat1)
		sCapt += " за "+ StrDat(dat1, "DMY") +" - "+ StrDat(dat2, "DMY");
	if(oStreet!=null && oStreet.getCod()!=0)
		sCapt += ": "+ oStreet.getTxt();
	if(oHouse!=null)
		sCapt += " "+ getHouseNom(oHouse.getFWID());
	
	return sCapt;
}

function listSrc()
{	
	this.qrySet("From", tblOut, "Order", "FSTREET, FHOUSE, FPLAT");
	
	//this.clTie("plt", "="+ getPar("CODPLAT") +", FPLAT", "a1");	
	this.subTie("cl", "str", "FWID", "FSTREET");
	this.subTie("cl_house", "hs", "FWID_CL", "FHOUSE");
	this.subTie("cl_apartment", "apt", "FWID_CL", "FAPMT");
	this.subTie("CONTRACT", "contr", "FWID", "FID_DOG");
}

function listAsk()
{
	var p = new Object();
	if(extPar)
		p = extPar;
	p.tblName = tblOut;
	p.label = label;
	p.lot = true;
	showWindow("i_vedku.xml", SW_MODAL, p);
	if (!p.escape)
    {
    	rdat1 = p.idat1;
	    rdat2 = p.idat2;
	    houseID = p.ihouse.getFWID();
	    streetID = p.istreet.getFWID();
	    platCod = p.iplat.getCod();
	    if(p.ilot)
	    	lot = p.ilot.getCod();
	    if(p.igek)
	    	gek = p.igek.getCod();
    }    
	return p;
}

function listMake()
{
	tblReg = hocRegTblName();
	var sSql = "select * from ^"+ tblReg +" where 1<>1";
	if(!lpProxy.getDBManager().testSQL(sSql))
	{
		var sMsg = UR("Не налагоджений журнал реєстрації оплат!"
					+"|Не настроен журнал регистрации оплат!")
		alert(sMsg);
		return false;
	}
	
	var nPr = 1;
	var sPrText = ru("Расчет...","Розрахунок...");
	setProgressRange(0, 7);
	setProgressPos(nPr++, sPrText);
	
	createOutTable();
	setProgressPos(nPr++, sPrText);
		
	var sFldSum = "FSUM";
	var sFldDat = "FDATE";
	var sFldOrg = "FORG";
	
	var tblLic = "LICSC"; 		 //таблица лицевых счетов
	var tblHs = "CL_HOUSE"; 	 //дома
	var tblApt = "CL_APARTMENT"; //квартиры
		
	var sWhere = " where 1=1 ";
	if(rdat1!=null && rdat2!=null)	//отбор за период
		sWhere += " and (sku.FDOC_DAT>="+ sqlTo(rdat1) 
				  +" and sku.FDOC_DAT<="+ sqlTo(rdat2) +")";
	if(streetID!=null)			//отбор по улице
		sWhere += " and hs.FSTREET="+ streetID;	
	if(houseID!=null)			//отбор по дому
		sWhere += " and hs.FWID_CL="+ houseID;
	if(lot)
		sWhere += " and hs.FLOT="+ lot;
	if(gek)
		sWhere += " and hs.FGEK="+ gek;
	if(platCod)					//отбор по плательщику
		sWhere += " and sku.FORG="+ platCod;	
	
	//сбрасываем все счета и оплаты по контрагентам в одну таблицу	
	var tblDept = tblOut +"_DEPT";
	ExecuteSQL("DROP TABLE "+ tblDept, false);
	ExecuteSQL("CREATE TABLE "+ tblDept 
				+"(FPLAT "+ SqlType("INT") 
				+", FID_DOG"+ SqlType("LONG") 
				+", FSUM"+ SqlType("CURRENCY") 
				+", FPLATSUM"+ SqlType("CURRENCY") +")"
				);
	
	var sumSku = IIF("r.FISSKU="+ sqlTrue, "r.FSUM_SKU", 0);
	var sumPlat = IIF("r.FISSKU="+ sqlFalse, "r.FSUM", 0);
	var sSql = "insert into "+ tblDept +"(FPLAT, FID_DOG, FSUM, FPLATSUM)"
				+" select r.FORG, r.FID_DOG, sum"+ sumSku +" as FSUM"
					+", sum"+ sumPlat +" as FPLATSUM"
				+" from ^"+ tblReg +" r "
				+(rdat1!=null? " where r.FDATE<"+ sqlTo(rdat1) : "")
				+" group by r.FORG, r.FID_DOG";
	ExecuteSQL(sSql);
	setProgressPos(nPr++, sPrText);
	
	//показания счетчиков
	var tblCounters = tblOut +"_COUNTERS";
	ExecuteSQL("DROP TABLE "+ tblCounters, false);
	ExecuteSQL("select * into "+ tblCounters
				+" from ^COUNTERS"
				+" where FDATE>="+ sqlTo(rdat1)
					+ (rdat2? " and FDATE<="+ sqlTo(rdat2) : "")
					+ (platCod? " and FORG="+ sqlTo(platCod) : "")
					+ (houseID? " and FHOUSE="+ sqlTo(houseID) : "")
					+" and FDIFFERENCE<>0"
				);
	
	var tblScore = tblOut +"_SCORE";	
	ExecuteSQL("DROP TABLE "+ tblScore, false);
	var sSql = "select FORG as FPLAT, FID_DOG"
					+", max(FDATE) as FDATE"
					+", max(FREGDATE) as FREGDATE"
					+", max("+ IIF("FSERV='HWATER'", "FPREVIOUS", "0") +") as FHOTPREV"
					+", max("+ IIF("FSERV='HWATER'", "FCURRENT", "0") +") as FHOTCUR"
					+", max("+ IIF("FSERV='HWATER'", "FDIFFERENCE", "0") +") as FHOTDIF"
					+", max("+ IIF("FSERV='CWATER'", "FPREVIOUS", "0") +") as FCOOLPREV"
					+", max("+ IIF("FSERV='CWATER'", "FCURRENT", "0") +") as FCOOLCUR"
					+", max("+ IIF("FSERV='CWATER'", "FDIFFERENCE", "0") +") as FCOOLDIF"
					+", max("+ IIF("FSERV='DRAIN' or FSERV='CDRAIN' or FSERV='HDRAIN'", "FPREVIOUS", "0") +") as FDRAINPREV"
					+", max("+ IIF("FSERV='DRAIN' or FSERV='CDRAIN' or FSERV='HDRAIN'", "FCURRENT", "0") +") as FDRAINCUR"
					+", max("+ IIF("FSERV='DRAIN' or FSERV='CDRAIN' or FSERV='HDRAIN'", "FDIFFERENCE", "0") +") as FDRAINDIF"
					+", max("+ IIF("FSERV='HEAT'", "FPREVIOUS", "0") +") as FHEATPREV"
					+", max("+ IIF("FSERV='HEAT'", "FCURRENT", "0") +") as FHEATCUR"
					+", max("+ IIF("FSERV='HEAT'", "FDIFFERENCE", "0") +") as FHEATDIF"
					+", max("+ IIF("FSERV='GAS'", "FPREVIOUS", "0") +") as FGASPREV"
					+", max("+ IIF("FSERV='GAS'", "FCURRENT", "0") +") as FGASCUR"
					+", max("+ IIF("FSERV='GAS'", "FDIFFERENCE", "0") +") as FGASDIF"
					+", max("+ IIF("FSERV='ELECTRIC'", "FPREVIOUS", "0") +") as FELECTRICPREV"
					+", max("+ IIF("FSERV='ELECTRIC'", "FCURRENT", "0") +") as FELECTRICCUR"
					+", max("+ IIF("FSERV='ELECTRIC'", "FDIFFERENCE", "0") +") as FELECTRICDIF"
				+" into "+ tblScore
				+" from "+ tblCounters
				+" group by FORG, FID_DOG";
	ExecuteSQL(sSql);
	setProgressPos(nPr++, sPrText);
	/*
	//объемы для квартир без счетчиков
	sSql = "insert into "+ tblScore
			+" (FPLAT, FID_DOG, FDATE, FHOTDIF, FCOOLDIF, FHEATDIF, FGASDIF, FELECTRICDIF) "
			+" select sku.FORG, sku.FID_DOG, sku.FDOC_DAT, sum(sku.FHOTDIF), sum(sku.FCOOLDIF), sum(sku.FHEATDIF), sum(sku.FGASDIF), sum(sku.FELECTRDIF) "
			+" from ^"+ tblSku +" as sku "
				+" left join "+ tblCounters +" c on c.FID_DOG=sku.FID_DOG and c.FORG is NULL"
			+" where sku.FDOC_DAT>="+ sqlTo(rdat1)
				+(rdat2? " and sku.FDOC_DAT<="+ sqlTo(rdat2) : "")
				+(platCod? " and sku.FORG="+ sqlTo(platCod) : "")
	ExecuteSQL(sSql);
	setProgressPos(nPr++, sPrText);
	*/
	/*
	sSql = "delete from "+ tblScore
			+" where FID_DOG in (select sku.FID_DOG from ^"+ tblSku +" as sku "
					+" where sku.FDOC_DAT>=FDATE"
						+(rdat1? " and sku.FDOC_DAT<="+ sqlTo(rdat1) : "")
						+" and sku.FCOUNTER_INIT="+ sqlTrue 
					+")";
	ExecuteSQL(sSql);
	setProgressPos(nPr++, sPrText);
	
	sSql = "insert into "+ tblScore
			+" (FPLAT, FID_DOG, FDATE, FHOT, FCOOL, FHEAT, FGAS, FELECTRIC) "
			+" select FORG, FID_DOG, FDOC_DAT, FHOT, FCOOL, FHEAT, FGAS, FELECTRIC "
			+" from ^"+ tblSku +" as sku "
			+" where FID_DOG not in (select FID_DOG from "+ tblScore +")"
				+(rdat1? " and sku.FDOC_DAT<="+ sqlTo(rdat1) : "")
				+" and sku.FCOUNTER_INIT="+ sqlTrue				
	ExecuteSQL(sSql);
	setProgressPos(nPr++, sPrText);
	*/
	var sOutFld = "FTT, FSTREET, FHOUSE, FAPMT, FID_DOG, FPLAT"
				+", FLIVAREA, FLOGAREA, FBALAREA, FRENT_BILL"
				+", FRENT, FHEAT, FCOOL, FHOT, FWREMOV, FGAS"
				+", FELECTRIC, FTRASH, FOTHER, FSUBSERV"
				+", FDATE, FSUM, FSUB"
				+", FEXEMPT, FSUPPORT, FPLATSUM, FDEPT"
				+", FDOC, FNOP, FFIO, FAPMTNOM"
				+", FPERSKOL, FEXMPTKOL"
				+", FHOTVOL, FCOOLVOL, FHOTCUR, FCOOLCUR"
				+", FHOTPREV, FCOOLPREV"
				+", FDRAINVOL, FDRAINCUR, FDRAINPREV"
				+", FELECTRICVOL, FELECTRICCUR, FELECTRICPREV"
				+", FGASVOL, FGASCUR, FGASPREV"
				+", FHEATVOL, FHEATCUR, FHEATPREV"
				+", FRECALC, FPENALTY, FRENT_TARIF"
	
	//исходные данные по контрагентам
	var sSql = "INSERT INTO "+ tblOut +" ("+ sOutFld +")" 
				+" SELECT "+ sqlEmpStr +" as FTT, max(hs.FSTREET), max(lic.FHOUSE)"
					+", max(lic.FAPMT), sku.FID_DOG, sku.FORG "
					+", max(apt.FLIVAREA), max(apt.FLOGAREA), max(apt.FBALAREA)"
					//+", sum((apt.FLIVAREA+apt.FLOGAREA*0.5+apt.FBALAREA*0.3)*sku.FRENT) as FRENT_BILL"
					+", sum(sku.FRENTSUM+sku.FRENTEXT+sku.FRENTSUB) as FRENT_BILL"
					+", sum(sku.FRENTSUM) as FRENT"
					+", sum(sku.FHEATSUM) as FHEAT"
					+", sum(sku.FCOOLSUM) as FCOOL"
					+", sum(sku.FHOTSUM) as FHOT"
					+", sum(sku.FWREMOVSUM) as FWREMOV"
					+", sum(sku.FGASSUM) as FGAS"
					+", sum(sku.FELECTRICSUM) as FELECTRIC"
					+", sum(sku.FTRASHSUM) as FTRASH"
					+", sum(sku.FOTHERSUM) as FOTHER"
					+", sum(sku.FSUBSERV) as FSUBSERV"
					+","+ sqlD00//+", sku.FDOC_DAT as FDATE" 
					+", sum(sku.FSUM) as FSUM"
					+", sum(sku.FSUB) as FSUB"
					+", sum(sku.FEXT) as FEXEMPT"
					+", sum(sku.FSUPPORT) as FSUPPORT"
					+", 0"//+", "+ IIF(platSum +" is null", "0", platSum) +" as FPLATSUM"
					+", 0"//+", "+ IIF(dept +" is null", "0", dept) +" as FDEPT"
					+", '' as FDOC, 0 as FNOP"
					+", max(cl.FTXT) as FFIO, max(apt.FNOM)"
					+", max(lic.FPERSKOL) as FPERSKOL" 	//", 0 as FPERSKOL"
					+", max(lic.FEXTKOL) as FEXMPTKOL"	//", 0 as FEXMPTKOL"				
					+", sum(s.FHOTDIF) as FHOTVOL"
					+", "+ IIF("s.FCOOLDIF is NULL", "sku.FCOOLDIF", "sum(s.FCOOLDIF)") +" as FCOOLVOL"
					+", max(s.FHOTCUR) as FHOTCUR"
					+", max(s.FCOOLCUR) as FCOOLCUR"
					+", max(s.FHOTPREV) as FHOTPREV"
					+", max(s.FCOOLPREV) as FCOOLPREV"
					+", "+ IIF("s.FDRAINDIF is NULL", "sku.FDRAINDIF", "sum(s.FDRAINDIF)") +" as FDRAINVOL"
					+", max(s.FDRAINCUR) as FDRAINCUR"
					+", max(s.FDRAINPREV) as FDRAINPREV"				
					+", "+ IIF("s.FELECTRICDIF is NULL", "sku.FELECTRDIF", "sum(s.FELECTRICDIF)") +" as FELECTRICVOL"
					+", max(s.FELECTRICCUR) as FELECTRICCUR"
					+", max(s.FELECTRICPREV) as FELECTRICPREV"
					+", "+ IIF("s.FGASDIF is NULL", "sku.FGASDIF", "sum(s.FGASDIF)") +" as FGASVOL"
					+", max(s.FGASCUR) as FGASCUR"
					+", max(s.FGASPREV) as FGASPREV"
					+", "+ IIF("s.FHEATDIF is NULL", "sku.FHEATDIF", "sum(s.FHEATDIF)") +" as FHEATVOL"
					+", max(s.FHEATCUR) as FHEATCUR"
					+", max(s.FHEATPREV) as FHEATPREV"
					+", max(sku.FRECALC) as FRECALC"
					+", max(sku.FPENALTY) as FPENALTY"
					+", max(sku.FRENT) as FRENT_TARIF" 
				+" FROM ^"+ tblSku +" sku "
					+" INNER JOIN ^CLRELCLCL as rel ON rel.FCOD=sku.FORG and rel.FCL=0 "
					+" INNER JOIN ^CL as cl ON cl.FWID=rel.FWID_CL "
					+" INNER JOIN ^"+ tblLic +" as lic ON lic.FID_DOG=sku.FID_DOG "
					+" LEFT JOIN ^"+ tblApt +" as apt ON apt.FWID_CL=lic.FAPMT "
					+" INNER JOIN ^"+ tblHs +" as hs ON hs.FWID_CL=lic.FHOUSE "
					+" LEFT JOIN ^"+ tblScore +" as s ON s.FID_DOG=sku.FID_DOG "
				+ sWhere
				+ " group by sku.FID_DOG, sku.FORG";
	ExecuteSQL(sSql);
	setProgressPos(nPr++, sPrText);
	
	//ExecuteSQL("update "+ tblOut +" set FRENT_BILL=(FLIVAREA+FLOGAREA*0.5+FBALAREA*0.3)*FRENT_TARIF");
	//setProgressPos(nPr++, sPrText);
	
	var sSql = "update "+ tblOut
				+" set FDEPT=(select sum(d.FSUM-d.FPLATSUM)" 
					+" from "+ tblDept +" d "
					+" where d.FPLAT="+ tblOut +".FPLAT "
						+" and d.FID_DOG="+ tblOut +".FID_DOG"
					+" group by d.FPLAT, d.FID_DOG"
					+")"
				+" where exists (select d.FSUM-d.FPLATSUM" 
					+" from "+ tblDept +" d "
					+" where d.FPLAT="+ tblOut +".FPLAT"
						+" and d.FID_DOG="+ tblOut +".FID_DOG"
					+")";
	ExecuteSQL(sSql);
	setProgressPos(nPr++, sPrText);
	
	var sSql = "update "+ tblOut
				+" set FPLATSUM=(select sum(reg."+ sFldSum +")"
					+" from ^"+ tblReg +" reg "
					+" where reg."+ sFldOrg +"="+ tblOut +".FPLAT "
						+" and reg.FID_DOG="+ tblOut +".FID_DOG "
						+((rdat1!=null && rdat2!=null)? " and reg."+ sFldDat +">="+ sqlTo(rdat1) 
							+" and reg."+ sFldDat +" <="+ sqlTo(rdat2) 
						: " and reg."+ sFldDat +">="+ tblOut +".FDOC_DAT")
					+" group by reg."+ sFldOrg 
					+")"
				+" where exists (select reg."+ sFldSum
					+" from ^"+ tblReg +" reg "
					+" where reg."+ sFldOrg +"="+ tblOut +".FPLAT "
						+" and reg.FID_DOG="+ tblOut +".FID_DOG "
						+((rdat1!=null && rdat2!=null)? " and reg."+ sFldDat +">="+ sqlTo(rdat1) 
							+" and reg."+ sFldDat +" <="+ sqlTo(rdat2) 
						: " and reg."+ sFldDat +">="+ tblOut +".FDOC_DAT")
					+")";
	ExecuteSQL(sSql);
	setProgressPos(nPr++, sPrText);
		
	//итоги
	ExecuteSQL("DROP TABLE "+ tblOut +"_ITOG", false);
	sFromFld = "0 as FAPMT, 0 as FID_DOG, 0 as FPLAT"
				+", sum(FLIVAREA) as FLIVAREA"
				+", sum(FLOGAREA) as FLOGAREA"
				+", sum(FBALAREA) as FBALAREA"
				+", sum(FRENT_BILL) as FRENT_BILL"
				+", sum(FRENT) as FRENT, sum(FHEAT) as FHEAT"
				+", sum(FCOOL) as FCOOL, sum(FHOT) as FHOT"
				+", sum(FWREMOV) as FWREMOV"
				+", sum(FGAS) as FGAS, sum(FELECTRIC) as FELECTRIC"
				+", sum(FTRASH) as FTRASH"
				+", sum(FOTHER) as FOTHER, sum(FSUBSERV) as FSUBSERV"
				+", "+ sqlTo(list.objAsk.rdate) +" as FDATE" 
				+", sum(FSUM) as FSUM, sum(FSUB) as FSUB"
				+", sum(FEXEMPT) as FEXEMPT, sum(FSUPPORT) as FSUPPORT"
				+", sum(FPLATSUM) as FPLATSUM, sum(FDEPT) as FDEPT"
				+", '' as FDOC"
				+", 0 as FNOP"
				+", '' as FFIO, '' as FAPMTNOM"
				+", sum(FPERSKOL) as FPERSKOL, sum(FEXMPTKOL) as FEXMPTKOL"
				+", sum(FHOTVOL) as FHOTVOL, sum(FCOOLVOL) as FCOOLVOL"
				+", 0 as FHOTCUR, 0 as FCOOLCUR"
				+", 0 as FHOTPREV, 0 as FCOOLPREV"
				+", sum(FDRAINVOL) as FDRAINVOL"
				+", 0 as FDRAINCUR, 0 as FDRAINPREV"
				+", sum(FELECTRICVOL) as FELECTRICVOL"
				+", 0 as FELECTRICCUR"
				+", 0 as FELECTRICPREV"
				+", sum(FGASVOL) as FGASVOL"
				+", 0 as FGASPREV"
				+", 0 as FGASCUR"
				+", sum(FHEATVOL) as FHEATVOL"
				+", 0 as FHEATCUR"
				+", 0 as FHEATPREV"
				+", sum(FRECALC) as FRECALC"
				+", sum(FPENALTY) as FPENALTY"
				+", 0 as FRENT_TARIF"
				
	//самая итоговая строка (по жэку)
	sSql = "select 'SUM' as FTT, 0 as FSTREET, 0 as FHOUSE, "+ sFromFld
			+" into "+ tblOut +"_ITOG from "+ tblOut;	
	ExecuteSQL(sSql);
	setProgressPos(nPr++, sPrText);	
		
	//по домам 
	sSql = "insert into "+ tblOut +"_ITOG ("+ sOutFld +")"
			+" select 'HS' as FTT, FSTREET, FHOUSE, "+ sFromFld 
			+" from "+ tblOut
			+" group by FSTREET, FHOUSE";
	if(!houseID && !platCod)//если не по одному дому
		ExecuteSQL(sSql);
	setProgressPos(nPr++, sPrText);
				
	sSql = "INSERT INTO "+ tblOut +" ("+ sOutFld +")" 
			+" SELECT "+ sOutFld 
			+" FROM "+ tblOut +"_ITOG";
	ExecuteSQL(sSql);
	setProgressPos(nPr++, sPrText);	
			
	ExecuteSQL("update "+ tblOut +" set FBILLSUM=FSUM+FSUPPORT");
	setProgressPos(nPr++, sPrText);
	
	//сальдо
	sSql = "UPDATE "+ tblOut 
		+" SET FBBALANS=(FDEPT)"
			+", FEBALANS="+ sqlRound("FDEPT + FSUM - FPLATSUM", getPar("DECISUM"));
	ExecuteSQL(sSql);
	
	
	sSql = "UPDATE "+ tblOut 
		+" SET FCOOLPREV=0 "
		+" WHERE FCOOLPREV>FCOOLCUR";
	ExecuteSQL(sSql);
	
	sSql = "UPDATE "+ tblOut 
		+" SET FHOTPREV=0 "
		+" WHERE FHOTPREV>FHOTCUR";
	ExecuteSQL(sSql);
	
	sSql = "UPDATE "+ tblOut 
		+" SET FDRAINPREV=0 "
		+" WHERE FDRAINPREV>FDRAINCUR";
	ExecuteSQL(sSql);
	
	sSql = "UPDATE "+ tblOut 
		+" SET FHEATPREV=0 "
		+" WHERE FHEATPREV>FHEATCUR";
	ExecuteSQL(sSql);
	
	sSql = "UPDATE "+ tblOut 
		+" SET FGASPREV=0 "
		+" WHERE FGASPREV>FGASCUR";
	ExecuteSQL(sSql);
	
	sSql = "UPDATE "+ tblOut 
		+" SET FELECTRICPREV=0 "
		+" WHERE FELECTRICPREV>FELECTRICCUR";
	ExecuteSQL(sSql);
	
	setProgressPos(0);
}

function createOutTable(sTblName)
{
	if(!sTblName)
		sTblName = tblOut;
	if(!ExecuteSQL("DROP TABLE "+ sTblName, false))
		ExecuteSQL("DELETE FROM "+ sTblName, false)
	var sSql = "CREATE TABLE "+ sTblName 
			+"(FPLAT "+ SqlType("INT") 		//плательщик: FORG из табл RAS_SKU, он же FCOD табл CLRELCLCL (справочник аналитики 2-го вида)
			+", FID_DOG"+ SqlType("LONG")	//договор: FID_DOG из табл RAS_SKU, он же FID_DOG табл LICSC, он же FWID табл CONTRACT
			+", FAPMT"+ SqlType("LONG")		//квартира: FWID_CL табл CL_APARTMENT, он же FAPMT из табл LICSC. вытягивается по FID_DOG табл RAS_SKU
			+", FHOUSE"+ SqlType("LONG")	//дом: FWID_CL табл CL_HOUSE, он же FHOUSE из табл CL_APARTMENT. вытягивается по FAPMT табл LICSC
			+", FSTREET"+ SqlType("LONG")	//улица: FSTREET из табл CL_HOUSE, он же FWID табл CL (справочник 1-го вида). вытягивается по FHOUSE табл CL_APARTMENT
			+", FLIVAREA"+ SqlType("DOUBLE")//жилая площадь: FLIVAREA из табл CL_APARTMENT
			+", FLOGAREA"+ SqlType("DOUBLE")//площадь лоджий: FLOGAREA из табл CL_APARTMENT
			+", FBALAREA"+ SqlType("DOUBLE")//площадь балконов: FBALAREA из табл CL_APARTMENT
			+", FFIO "+ SqlType("TEXT")		//ФИО плательщика: FTXT табл CL
			+", FAPMTNOM"+ SqlType("TEXT")	//номер квартиры: FNOM табл CL_APARTMENT
			+", FWCOUNTER"+ SqlType("BIT")	//налич.сч.воды
			+", FGCOUNTER"+ SqlType("BIT")	//налич.сч.газа
			+", FPERSKOL"+ SqlType("INT")	//колич. жильцов: FPERSKOL табл LICSC
			+", FEXMPTKOL"+ SqlType("INT")	//колич. льготников: FEXMPTKOL табл LICSC						
			+", FDATE"+ SqlType("DATE")		//дата: FDOC_DAT табл RAS_SKU
			+", FDOC"+ SqlType("TEXT")		//метка платежного поручения
			+", FNOP"+ SqlType("INT")		//номер операции платежки
			+", FTT"+ SqlType("TEXT")		//итог			
			+", FSUB"+ SqlType("CURRENCY")	//сумма субсидий
			+", FEXEMPT"+ SqlType("CURRENCY")	//сумма льгот
			+", FBILLSUM"+ SqlType("CURRENCY")	//общая сумма с уч. льгот и субсидий
			+", FSUPPORT"+ SqlType("CURRENCY")	//адресная помощь
			+", FSUM"+ SqlType("CURRENCY")		//общая сумма с учетом адресной помощи
			+", FBBALANS"+ SqlType("CURRENCY")	//сальдо на начало
			+", FEBALANS"+ SqlType("CURRENCY")	//сальдо на конец
			+", FPLATSUM"+ SqlType("CURRENCY")	//сумма оплаченная: FSUM из журнала регистрации по документу PP.
			+", FDEPT"+ SqlType("CURRENCY")		//долг на начало
			//суммы по услугам с учетом льгот. из табл RAS_SKU
			+", FRENT"+ SqlType("CURRENCY")		//квартплата
			+", FRENT_TARIF"+ SqlType("CURRENCY")//квартплата тариф
			+", FRENT_BILL"+ SqlType("CURRENCY")//квартплата начислено			
			+", FHEAT"+ SqlType("CURRENCY")		//отопление
			+", FCOOL"+ SqlType("CURRENCY")		//хол. вода
			+", FHOT"+ SqlType("CURRENCY")		//гор. вода
			+", FGAS"+ SqlType("CURRENCY")		//газ (и коню понятно)
			+", FELECTRIC"+ SqlType("CURRENCY")	//электроэнергия
			+", FWREMOV "+ SqlType("CURRENCY")	//водоотведение
			+", FTRASH"+ SqlType("CURRENCY")	//Вывоз мусора
			+", FOTHER "+ SqlType("CURRENCY")	//Другое
			+", FSUBSERV "+ SqlType("CURRENCY")	//Доп. услуги
			//объемы использ. воды
			+", FHOTVOL"+ SqlType("DOUBLE")	 	//гор.
			+", FCOOLVOL"+ SqlType("DOUBLE") 	//хол.
			+", FHOTCUR"+ SqlType("DOUBLE") 	//
			+", FCOOLCUR"+ SqlType("DOUBLE")	//
			+", FHOTPREV"+ SqlType("DOUBLE") 	//
			+", FCOOLPREV"+ SqlType("DOUBLE")	//
			+", FDRAINVOL"+ SqlType("DOUBLE")	//водоотведение
			+", FDRAINCUR"+ SqlType("DOUBLE")	//
			+", FDRAINPREV"+ SqlType("DOUBLE")	//			
			//
			+", FHEATVOL"+ SqlType("DOUBLE")	//
			+", FHEATCUR"+ SqlType("DOUBLE")	//
			+", FHEATPREV"+ SqlType("DOUBLE")	//
			+", FGASVOL"+ SqlType("DOUBLE")	 	//
			+", FGASCUR"+ SqlType("DOUBLE")	 	//
			+", FGASPREV"+ SqlType("DOUBLE")	//
			+", FELECTRICVOL"+ SqlType("DOUBLE")//
			+", FELECTRICCUR"+ SqlType("DOUBLE")//
			+", FELECTRICPREV"+ SqlType("DOUBLE")//
			//
			+", FRECALC"+ SqlType("CURRENCY") 	//перерасчет
			+", FPENALTY"+ SqlType("CURRENCY") 	//пеня
			+", FWID"+ SqlType("COUNTER")
			+")";			
	ExecuteSQL(sSql, false);
}

function hocRegTblName()
{		
	if(!jID || jID=="")
		jID = getPar("HOCPAYREG");		
	var sPath = getPath("UJ");
	var sTblName = sPath +".UJ_KU";	
	if(jID!=null && jID!="")
		sTblName = sPath +".UJ_"+ jID;		
	return sTblName;
}

function getHouseNom(fwid_cl)
{
	var sNom = "";
	if(!fwid_cl)
		fwid_cl = houseID;
	var sSql = "select rel.fcod, h.fnom, h.fwid_cl from ^cl_house h "
				+" inner join ^clrelclcl rel on rel.fwid_cl=h.fwid_cl "
				+" where h.fwid_cl="+ fwid_cl;
	var oHs = getSnap(sSql, false);
	if(oHs!=null && oHs[1]!=null)
		sNom = oHs[1];
	return sNom;	
}

function getSDat(date)
{	
	if(!date)
	{
		var oSnap = getSnap("select FDATE from "+ tblOut +" order by FDATE", false);
		if(oSnap!=null)
			date = toScriptDate(oSnap[0]);
	}
	var sMonth = tmonth(date, 3);
	var sYear = date.getYear() + 1900;
	return sMonth +" "+ sYear;
}

function getAddr()
{
	var sAddr = "";
	var oSnap = getSnap("select r.FSTREET,r.FHOUSE,cl.FTXT "
					+" from "+ tblOut +" r inner join ^CL cl on cl.FWID=r.Fstreet "
					+" where r.Fhouse<>0", false);
	if(oSnap!=null && oSnap[0]!=0)
		sAddr = oSnap[2] +" "+ getHouseNom(oSnap[1]);

	return sAddr;
}

function getSum(sFld, sWhere)
{
	if(!sFld)
		sFld = "FSUM";
	if(!sWhere)
		sWhere = "FTT='SUM'"
	var oSnap = getSnap("select sum("+ sFld +") from "+ tblOut +" where "+ sWhere);
	if(oSnap && Number(oSnap[0]))
		return round(oSnap[0], getPar("DECISUM"));
	return 0;
}

function listOnPrnList(tv)
{			
	tv.eval.addVar("DATE", getSDat());
	tv.eval.addVar("ADDR", getAddr());
	tv.eval.addVar("BDAT", list.objAsk.idat1);
	tv.eval.addVar("EDAT", list.objAsk.idat2);
	
	var tPrn = OpenTable("s", "select * from "+ tblOut 
				+" where FTT='SUM'");
	var arrFld = getColumn(tblOut).split(",");
	for(var n=0; n<arrFld.length; n++)
	{
		var sFld = arrFld[n];
		tv.eval.addVar(sFld, tPrn.getValue(sFld));
	}
}

function listMenuInit(ds)
{
	ds.AddMenuItem("DEBT", "Боржники|Должники");
	//ds.AddMenuItem("ZRPLIST", "Реєстр утримань із зарплати|Реестр удержаний из зарплаты");
}

function listMenuRun(sID)
{
	if(sID=="DEBT")
	{
		var p = new Object();
		p.tblName = tblOut;
		showWindow("r_vedkud.js", SW_NOMODAL, p);		
	}/*
	else if(sID=="ZRPLIST")	//rovenki
	{
		var p = new Object();
		p.tblName = tblOut;
		showWindow("r_vedku_zrp.js", SW_NOMODAL, p);		
	}*/
}

include("sys/DpList.js");